//---------------------------------------------------------------------------

#include <vcl.h>
#include <string>
#include <iostream>
#include <algorithm>

#include <conio.h>   //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main (int argc, char* argv[])
{

  //   
  const string hello("Hello, how are you?");
  cout << ToRus(" :\n") << hello << endl;

  //   s    hello
  string s(hello.begin(),hello.end());

  //   
  cout << ToRus(" s:\n");
  string::iterator pos;
  for (pos = s.begin(); pos != s.end(); ++pos) {
      cout << *pos;
  }
  cout << endl;

  //      
  reverse (s.begin(), s.end());
  cout << ToRus("     :\n")
       << s << endl;

  //    
  sort (s.begin(), s.end());
  cout << ToRus(" :\n")
       << s << endl;

  //   
  //  - unique()       
  //  - erase()   
  s.erase (unique(s.begin(),
                  s.end()),
           s.end());
  cout << ToRus("  :\n")
       << s << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------